#ifndef _TFT_H_
#define _TFT_H_

#define PORT_DATA		PORTA	//  
#define DDR_DATA		DDRA
#define DATA_DDR 		DDRA
#define DATA_PORT		PORTA
#define DATA_PIN 		PINA
//-------------------------------- DC (RS)
#define COMDATA_DDR 	DDRC
#define COMDATA_PORT 	PORTC
//-------------------------------- WR, RD
#define CTRL1_DDR		DDRD
#define CTRL1_PORT		PORTD
//-------------------------------- RESET
#define CTRL2_DDR		DDRE
#define CTRL2_PORT		PORTE

#define LCD_RESET		0	//    ;
#define LCD_CD			3	// /,     , 
					//    - ;
#define LCD_RS			3	//  LCD_CD
#define LCD_WR			6	//   ,   ;
#define LCD_RD			7	//   ,   ;

#define RESET_IDLE 		CTRL2_PORT |= (1<<LCD_RESET)
#define WR_IDLE 		CTRL1_PORT |= (1<<LCD_WR)
#define RD_IDLE 		CTRL1_PORT |= (1<<LCD_RD)
#define RESET_ACTIVE 		CTRL2_PORT &= ~(1<<LCD_RESET)
#define WR_ACTIVE 		CTRL1_PORT &= ~(1<<LCD_WR)
#define RD_ACTIVE 		CTRL1_PORT &= ~(1<<LCD_RD)
#define CD_COMMAND 		COMDATA_PORT &= ~(1<<LCD_CD)
#define CD_DATA 		COMDATA_PORT |= (1<<LCD_CD)
#define setReadDir() 		DATA_DDR = 0x00
#define setWriteDir() 		DATA_DDR = 0xFF
#define WR_STROBE 		{WR_ACTIVE;WR_IDLE;}
#define BLACK 	0x0000
#define BLUE 	0x001F
#define RED 	0xF800
#define GREEN 	0x07E0
#define WHITE 	0xFFFF
#define CYAN 	0x07FF
#define MAGENTA 0xF81F
#define YELLOW 	0xFFE0

#define swap(a,b) {int16_t t=a;a=b;b=t;}

void TFT9341_Write8(unsigned char dt);
void TFT9341_DrawPixel(int x,int y,unsigned int color);
void TFT9341_WriteRegister32(unsigned char r, unsigned long d);
void print_str(
		unsigned char x_pos,
		unsigned char y_pos,
		unsigned char font_size,
		unsigned int colour,
		unsigned int back_colour,
		char *str);

void initTFT(void);
void TFT9341_Flood(unsigned short color, unsigned long len);
void TFT9341_SetRotation(unsigned char r);

void TFT9341_Draw_Char(
	int x,int y,unsigned int color, unsigned int backcolor, 
	unsigned char ch,unsigned char size);
unsigned int Color565(unsigned char r, unsigned char g, unsigned char b);
void TFT9341_FillScreen(unsigned int color);
void TFT9341_FillRectangle(
	unsigned int color,					// 
	unsigned int x1, unsigned int y1,	//   
	unsigned int x2, unsigned int y2);
void TFT9341_DrawLine(
	unsigned int color,
	unsigned int x1, unsigned int y1, 
	unsigned int x2, unsigned int y2);

#endif

